require ('/var/www/virtuals/old.gorod.ua/html/cgi-bin/creator/uri/uri_rewrite.pl');
###############################################################################
# getQuery( string )   Return hash of query parametrs.
# strUpper( string )   Convert string to uppercase.
# strLower( string )   Convert string to lower.
# win2koi( string )    Convert string from windows-1251 to koi8-r encoding.
# koi2win( string )    Convert string from koi8-r to windows-1251 encoding.
# checkInt( value )    Check is value type integer.
# checkFloat( value )  Check is value type float.
# readFile( filename ) Return file content or -1 if fail.
# money2str( value )   Convert float money to string.
# mkpass( len )	       Generate ramdom sequence.
# bold( msg ) 	       return bold message
# cbold( msg ) 	       return centred bold message
# error( err msg )     return red message
# fatal( err msg )     display msg and exit			
# parse($data) 	       return parsed data
# show_select( $hash_link, $name ) return <select></select> of hash
###############################################################################

sub getQuery
#Return hash of query parametrs.
#Parametrs: no
#Return value: hash of query parms.
{
  $len  = $ENV{'CONTENT_LENGTH'};
  $method = $ENV{'REQUEST_METHOD'};
  if( $method eq "POST" )
  {
   read(STDIN, $in, $len);
  }
  else 
  {
   $in = $ENV{'QUERY_STRING'};
  }

  @in = split(/[&;]/,$in); 
  foreach $i (0 .. $#in)
  {
    $in[$i] =~ s/\+/ /g;
    ($key, $val) = split(/=/,$in[$i],2);
    $orig_query{$key} .= "\0" if (defined($in{$key}));
    $orig_query{$key} .= $val;
    $key =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
    $val =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
    #Remove all HTML tags
    $val =~ s/<([^>]|\n)*>//g;
    $key =~ s/<([^>]|\n)*>//g;
    $in{$key} .= "\0" if (defined($in{$key}));
    $in{$key} .= $val;
  }
  return %in;
}

sub strUpper
#Convert string to uppercase
#Parametrs: 1-string
#Return value: Uppercase string
{
 my $var = $_[0];
 $var =~ tr/a-zţ/A-Z/;
 return $var;
}

sub strLower
#Convert string to lowercase
#Parametrs: 1-string
#Return value: Lowercase string
{
 my $var = $_[0];
 $var =~ tr/A-Z/a-zţ/;
 return $var;
}

sub koi2win
#Convert string from windows-1251 to koi8-r encoding
#Parametrs: 1-windows-1251 encoding string
#Return value: koi8-r encoding string
{
 my $var = $_[0];
 $var =~ tr/ų/ţ/;
 return $var;
}

sub win2koi
#Convert string from koi8-r to windows-1251 encoding
#Parametrs: 1-koi8-r encoding string
#Return value: windows-1251 encoding string
{
 my $var = $_[0];
 $var =~ tr/ţ/ų/;
 return $var;
}

sub checkInt
#Check is value type integer
#Parametrs: 1-value to will be checked
#Return value: if value type is integer then return 1 else 0
{
 my $var = $_[0];
 return 0 if( $var =~ /[^0-9]/ );
 return 1;
}

sub checkFloat
#Check is value type integer
#Parametrs: 1-value to will be checked
#Return value: if value type is integer then return 1 else 0
{
 my $var = $_[0];
 return 0 if( $var =~ /[^0-9\.]/ );
 return 1;
}

sub readFile($)
{
 my $data;
 my ($size) = (stat($_[0]))[7];
 return -1 if( !$size );
 open( F, $_[0] ) || return -1;
 sysread( F, $data, $size );
 close( F );
 return $data;
}

sub str2h($$$$)
{
 my ($grn, $male, $female, $mid ) = @_;
 my $r, $hh, $dd, $ee;
 
 my %hs = ( 1 => ' ',
	    2 => ' ',
	    3 => ' ', 
	    4 => ' ', 
	    5 => ' ', 
	    6 => ' ', 
	    7 => ' ', 
	    8 => ' ', 
	    9 => ' ' );

 my %ds = ( 1 => ' ',
	    2 => ' ',
	    3 => ' ',
	    4 => ' ',
	    5 => ' ',
	    6 => ' ',
	    7 => ' ',
	    8 => ' ',
	    9 => ' ');

 my %dds = ( 1 => ' ',
	     2 => ' ',
	     3 => ' ',
	     4 => ' ',
	     5 => ' ',
	     6 => ' ',
	     7 => ' ',
	     8 => ' ',
	     9 => ' ' );
	     
 my %ees = ( 1 => ' ',
	     2 => ' ' );
	     	    
 my %es = ( 1 => ' ',
	    2 => ' ',
	    3 => ' ',
	    4 => ' ',
	    5 => ' ',
	    6 => ' ',
	    7 => ' ',
	    8 => ' ',
	    9 => ' ' );
	
 my $h = int($grn/100); $grn = ($grn%100) if( $h );
 my $d = int($grn/10); $grn = ($grn%10) if( $d );
 my $e = $grn;
 
 $r = $mid;
 $hh = $hs{$h};
 $dd = $ds{$d};
 $ee = $es{$e};
 $r = $male if( $e == 1 );
 $r = $female if( $e > 1 && $e < 5 );
 if( $e > 0 && $e < 3 ) { $ee = $ees{$e}; }
 if( $d == 1 && $e > 0) { $dd = $dds{$e}; $ee = ''; $r = $mid; }

 return "$hh $dd $ee $r ";
}

sub money2str($)
{
 my $res ='';
 my $s;
 my ($grn, $kop) = split(/\./, $_[0]);
 $grn = '0' if( !$grn );
 $kop = '00' if( !$kop );
 my $m = int($grn/1000000);
 if( $m )
 {
  $grn = ($grn%1000000);
  $res .= str2h($m,'','','');
 }
 
 my $t = int($grn/1000);
 if( $t )
 {
   $grn = ($grn%1000);
   $res .= str2h($t,'','','');
 }
 
 my $h = $grn;
 $res .= str2h($h,'','','');
 $res =~ s/([\ ]+)//;
 $res =~ /([\x00-\xFF]{1})/;
 $s = $1;
 $s =~ tr///;
 $res =~ s/([\x00-\xFF]{1})/$s/;
 return "$res $kop .";
}

sub mkpass($)
{
 my @pass_string = qw(0 1 2 3 4 5 6 7 8 9 A B C D E F G H I J K L M N O P Q R S T U V W X Y Z a b c d e f g h i j k l m n o p q r s t u v w x y z);
 my $len = scalar(@pass_string);
 my $i;
 my $pass = '';
 
 for($i=0;$i<$_[0];$i++)
 {
  $pass .= $pass_string[int(rand($len-1))];
 }
 return $pass;
}

sub mkdigitpass($)
{
 my @pass_string = qw(0 1 2 3 4 5 6 7 8 9);
 my $len = scalar(@pass_string);
 my $i;
 my $pass = '';
 
 for($i=0;$i<$_[0];$i++)
 {
  $pass .= $pass_string[int(rand($len-1))];
 }
 return $pass;
}

sub bold($)
{
 return "<b>$_[0]</b>\n";
}

sub cbold($)
{
 return "<center><b>$_[0]</b></center><br>\n";
}

sub error($)
{
 return "<font color=\"red\"><b>$_[0]</b></font><br>\n";
}

sub fatal($)
{
 $output .= "<font color=\"red\"><b>$_[0]</b></font><br>\n";
 display($_[1]);
 exit(1);
}

sub parse($)
{
 $val = $_[0];
 $val =~ s/\"/\&quot\;/g;
 $val =~ s/\n/<br>/g;
 $val =~ s/>/&gt;/g;
 $val =~ s/</&lt;/g;
 $val =~ s/\'/&#39;/g;
 $val =~ s/\`/&#96;/g;
 return $val;
}

sub lparse($)
{
 $val = $_[0];
 $val =~ s/\"/\&quot\;/g;
 $val =~ s/>/&gt;/g;
 $val =~ s/</&lt;/g;
 $val =~ s/\'/&#39;/g;
 $val =~ s/\`/&#96;/g;
 return $val;
}

sub rlparse($)
{
 $val = $_[0];
 $val =~ s/\&quot\;/\"/g;
 $val =~ s/&gt;/>/g;
 $val =~ s/&lt;/</g;
 return $val;
}

sub show_select($$)
#1 - hash_link, 2 - name
{
 my ($hash, $name) = @_;
 my $res = "<select name=\"$name\">\n";
 
 foreach $key ( sort keys %$hash )
 {
  if( $query{$name} eq $key ) { $res .= "<option value=\"$key\" selected>$hash->{$key}</option>\n"; }
   else { $res .= "<option value=\"$key\">$hash->{$key}</option>\n"; }
 }
 $res .= "</select>\n";
 return $res;
}

sub display
#1 - template
{
 my $ftemplate = $_[0] if( $_[0] );
 return -1 if( !$TEMPLATE && !$ftemplate );
 $CHARSET = 'koi8-r' if( !$CHARSET );
 if( $ftemplate ){ $TEMPLATE = readFile($ftemplate); }
 print "Content-type: text/html; charset=$CHARSET\n\n";

 if( !$SKIP_TEMPLATE_TRANSLATE )
 {
  $TEMPLATE =~ s/ukr\-info\.net/gorod.dn.ua/g
   if( $ENV{'HTTP_HOST'} =~ 'gorod.dn.ua' );
 }
 if( !$SKIP_TRANSLATE )
 {
  $output =~ s/ukr\-info\.net/gorod.dn.ua/g
   if( $ENV{'HTTP_HOST'} =~ 'gorod.dn.ua' );
 }
 $TEMPLATE =~ s/\$output/$output/;
 $TEMPLATE =~ s/\$cid/$cid/g;
 $TEMPLATE =~ s/\$self/$self/g;
 # SSI
# while( $TEMPLATE =~ /include virtual=\"([\w\.\-\_\/]+)\"(.*)/gm )
# {
#  my $data = '';
#  my $file = $1;
#  
#  $file = "$ENV{'DOCUMENT_ROOT'}$file" if( $file =~ /^\// );
#  my ($fSize) = (stat($file))[7];
#  next if( !$fSize );
#  next if( !open( SSIFile, $file ) );
#  sysread( SSIFile, $data, $fSize );
#  close( SSIFile );
#  $TEMPLATE =~ s/<\!\-\-\s*#include virtual=\"[\w\.\-\_\/]+\"\s*-->/$data/;
# }
# while( $TEMPLATE =~ /exec cgi=\"([\w\.\-\_\/\s]+)\"(.*)/gm )
# {
#  my $file = $1;
#  $file = "$ENV{'DOCUMENT_ROOT'}$file" if( $file =~ /^\// );
#  my $data = `$file`;
#  if( $data =~ /Content\-type/i ) {
#   ($hdr, $data) = split(/[\r\n][\r\n]/, $data);
#  }
#  $data =~ s/.*[\r\n][\n\r]//g;
#  $TEMPLATE =~ s/<\!\-\-\s*#exec cgi=\"[\w\.\-\_\/\s]+\"\s*-->/$data/;
# }
 #
 if ($cid) {
  $TEMPLATE =~ s/(\<body .*?\>)/$1\n<!--#set var=\"MinisiteID\" value=\"$cid\" -->\n<script type=\"text\/javascript\">\nvar MinisiteID =\'$cid\';\n<\/script>\n/i;
  $TEMPLATE =~ s/(\<\/head\>)/<meta name=\"mid\" content=\"$cid\" \/>\n<meta name=\"suid\" content=\"40000$cid\" \/>\n$1/i;
 }
 $TEMPLATE =~ s/&lt;br&gt;/<br>/g;
 ur_process($template);
 print $TEMPLATE;
}

1;
